import { Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { HttpClient, HttpHeaders } from '@angular/common/http';

@Component({ templateUrl: 'recipe-details.component.html' })
export class RecipeDetailsComponent implements OnInit {
    recipeDetails;
    id?: string;
    ingredients = [];
    priceDetails;
    relatedRecipes;
    headers;
    constructor(private route: ActivatedRoute, private http: HttpClient) {
    }

    ngOnInit() {
        this.id = this.route.snapshot.params['id'];
        this.headers = new HttpHeaders({
            'x-api-key': 'd0f75f78c8d342e6b1d418cd2e2f31da'
        });
        if (this.id) {
            this.getRecipes()
            this.getRecipePrice()
            this.getRelatedRecipes()
        }
    }

    getRecipes() {
        let recipeUrl = "https://api.spoonacular.com/recipes/" + this.id + "/information/"
        this.http
            .get<any>(recipeUrl, {
                headers: this.headers
            })
            .subscribe(data => {
                this.recipeDetails = data;
                this.ingredients = data.extendedIngredients;
            });
    }

    getRecipePrice() {
        let recipePrice = "https://api.spoonacular.com/recipes/" + this.id + "/priceBreakdownWidget.json/"
        this.http
            .get<any>(recipePrice, {
                headers: this.headers
            })
            .subscribe(data => {
                this.priceDetails = data;

                console.log(data, ">>>>>>>>>PRICe>>>>>>>>>>>")
            });

    }

    getRelatedRecipes() {
        let relatedRecipes = "https://api.spoonacular.com/recipes/" + this.id + "/similar"
        this.http.get<any>(relatedRecipes, { headers: this.headers })
            .subscribe(data => {
                this.relatedRecipes = data;
            });
    }

    getInImage(val) {
        return "https://spoonacular.com/cdn/ingredients_100x100/" + val?.image
    }

    getReImage(val) {
        return "https://spoonacular.com/recipeImages/" + val?.id + "-312x231." + val?.imageType;
    }

    navigateToLink(val) {
        window.open(val.sourceUrl)
    }


}